package gov.nasa.ziggy.ui;

import javax.swing.GroupLayout;

/**
 * General constants used by the Ziggy Console.
 * <p>
 * Ziggy uses sentence capitalization for nearly all elements in menu items, button text, labels,
 * table headings.
 */
public class ZiggyGuiConstants {

    public static final int MAIN_WINDOW_WIDTH = 1400;
    public static final int MAIN_WINDOW_HEIGHT = 900;

    /**
     * The size of the gap between the container and components that touch the border of the
     * container. In most cases, {@link GroupLayout#setAutoCreateContainerGaps(boolean)} adds a
     * little breathing room around a panel.
     */
    public static final int CONTAINER_GAP = 5;

    // Button and menu item strings.
    public static final String ABOUT = "About";
    public static final String ADD = "Add";
    public static final String ADD_SYMBOL = "+";
    public static final String ASSIGN_GROUP = "Assign group";
    public static final String CANCEL = "Cancel";
    public static final String CLOSE = "Close";
    public static final String COLLAPSE_ALL = "Collapse all";
    public static final String COPY = "Copy";
    public static final String CREATE = "Create";
    public static final String DELETE = "Delete";
    public static final String DIALOG = "...";
    public static final String EDIT = "Edit";
    public static final String EXIT = "Exit";
    public static final String EXPAND_ALL = "Expand all";
    public static final String EXPORT = "Export";
    public static final String FILE = "File";
    public static final String HELP = "Help";
    public static final String IMPORT = "Import";
    public static final String NEW = "New";
    public static final String OK = "OK";
    public static final String REFRESH = "Refresh";
    public static final String REMOVE = "Remove";
    public static final String REMOVE_SYMBOL = "-";
    public static final String RENAME = "Rename";
    public static final String REPORT = "Report";
    public static final String RESTART = "Restart";
    public static final String RESTORE_DEFAULTS = "Restore defaults";
    public static final String SAVE = "Save";
    public static final String SELECT = "Select";
    public static final String START = "Start";
    public static final String TO_BOTTOM = "To bottom";
    public static final String TO_TOP = "To top";
    public static final String VIEW = "View";
}
